function initilizeStrings(){


var title=chrome.i18n.getMessage("title");
document.getElementById("header").innerHTML=title;

var buttoncaption=chrome.i18n.getMessage("buttoncaption");
document.getElementById("caption").innerHTML=buttoncaption;

var message=chrome.i18n.getMessage("portmessage");
document.getElementById("message").innerHTML=message;


var portno=chrome.i18n.getMessage("port");
document.getElementById("portno").innerHTML=portno;

var enableInitScreen = chrome.i18n.getMessage("enableInitScreen");
document.getElementById("enableInitScreenLabel").innerHTML=enableInitScreen;
}

var savedConfig = {};
var requestURLString="";

// Saves options to localStorage.
function save_options() {
  
  validatePort();
  updateurl();
  for (var key in savedConfig) {
    var elem = document.getElementById(key);
    if (!elem) {
      chrome.extension.sendRequest({log: 'bad key ' + key});
      continue;
    }
    
    var val = elem.value;
    if(key == 'enableInitScreen')
    	val = elem.checked;
    
    chrome.extension.sendRequest({setConfig: true, key: key, val: val});
  }

  // Update status to let user know options were saved.
  var status = document.getElementById("status");
  status.innerHTML = chrome.i18n.getMessage("savemessage");
  setTimeout(function() {
    status.innerHTML = chrome.i18n.getMessage("savemessage");
  }, 1000);
}

// Restores select box state to saved value from localStorage.
function restore_options() {

  initilizeStrings();
  
  chrome.extension.sendRequest({getConfig: true}, function(config) {
    savedConfig = config;
    for (var key in config) {
      var val = config[key];
      if (val) {
        var elem = document.getElementById(key);
        if (!elem) {
          chrome.extension.sendRequest({log: 'bad key ' + key});
          continue;
        }
        if(key == 'enableInitScreen')
        	elem.checked=(val==="true");
        else
        	elem.value = val;
      }
    }
  });
}
function validatePort(){
     
var port=document.getElementById("portnumber").value;     
if(!port.match(/^\d+/)){        
 alert(chrome.i18n.getMessage("errormessage"));
 restore_options();        
 }  
}

function updateurl(){

 var port=document.getElementById("portnumber").value;
 var url=document.getElementById("urlstring").value;
 var urlSubstr = url.substring(url.lastIndexOf(":") + 1, url.lastIndexOf("rational_ft") - 1);
 var newurl=url.replace(urlSubstr, port);
 document.getElementById("urlstring").value=newurl;

}

document.addEventListener('DOMContentLoaded', function () {
  document.querySelector('button').addEventListener('click', save_options);
});


document.addEventListener("DOMContentLoaded", restore_options, false);


