
var config = {};
var requestURLString;
var enableInitScreenPref;

function loadConfigItem(item, defaultVal) {
  config[item] = defaultVal;
  try {
    var storedItem = window.localStorage[item];
    
    if (storedItem != null) config[item] = storedItem;
  } catch(e) {
	alert(e);
  }
}

function loadConfig() {
  loadConfigItem("portnumber", 9100);
  loadConfigItem("urlstring", "http://localhost:9100/rational_ft_htmljs.jar");
  loadConfigItem("enableInitScreen", true);
}
loadConfig();

chrome.extension.onRequest.addListener(function(req, sender, respond) {
  
  if(req.getConfig) {
   
   
    respond(config);
  } else if (req.setConfig) {
   
    localStorage[req.key] = req.val;
    loadConfig();
    respond({});
  }
  else if (req.getURLString) {
   
    var url="urlstring";
	
	requestURLString=window.localStorage[url];
	//alert(requestURLString);
    if(requestURLString==null)
	requestURLString="http://localhost:9100/rational_ft_htmljs.jar";
    respond(requestURLString);
  }
	else if (req.getEnableInitScreenPref) {
   enableInitScreenPref=window.localStorage["enableInitScreen"];
	respond(enableInitScreenPref);
  }
});



