/*
 *
 *	Licensed Materials - Property of IBM
 *
 *	IBM Rational Functional Tester
 *
 * (c) Copyright IBM Corporation 2013, 2015. All Rights Reserved.
 * (c) Copyright HCL Technologies Ltd. 2016. All Rights Reserved.
 *
 *	Note to U.S. Government Users Restricted Rights:  
 *	Use, duplication or disclosure restricted by GSA ADP
 *	Schedule Contract with IBM Corp. 
 *
 */

if(getChromeVer()<=44)
{
	document.addEventListener("DOMContentLoaded", this.createApplet,false);
	window.onload = this.unblockUI;
	var url, enableInitScreen;
	chrome.extension.sendRequest({getURLString : true}, function(requestURLString) {url = requestURLString;});
	chrome.extension.sendRequest({getEnableInitScreenPref : true}, function(requestEnableInitScreenPref) {enableInitScreen = requestEnableInitScreenPref;});
	setTimeout(function() {	createApplet()}, 500);
	setTimeout(function() {unblockUI()}, 10000);
}

function getChromeVer() {
	var index = 0, chromeVer = 45;
	var usrAgt = navigator.userAgent;
	if((index=usrAgt.indexOf("Chrome"))!=-1) {
		chromeVer = parseFloat(usrAgt.substring(index+7));
	}
	return chromeVer;
}

function createApplet()
{
	if(ignoredoc())return;
	if(url!= undefined)
	{
		if (enableInitScreen === "true") {console.log("Blocking UI");blockUI();}
		i = document.createElement("APPLET");
		i.id = "RFTMiniIcon";
		i.setAttribute("archive", url);
		i.setAttribute("code","com/ibm/rational/test/ft/domain/htmljs/FTHtmlJsWrapper.class");
		i.style.visibility = "hidden";
		document.body.appendChild(i);
		console.log("Created and added applet to document "+ document.URL);
	}}
function insertJquery() {
	console.log("in jquery check node creation");
	var scriptElement = document.createElement("script");
	scriptElement.id = "RFTjQueryChecker";
	var node = document.createTextNode("(function(){"
										+"	var rftJqueryCheck = setInterval(function(){"
										+"	if(document.readyState=='complete'){"
										+"	  clearInterval(rftJqueryCheck);"
										+"	  if(window.jQuery&&jQuery.fn){"
										+"	    console.log('jquery found in ' + document.URL);"
										+"	  }else{"
										+"	    console.log('jquery not found in ' + document.URL);"
										+"	    var scriptElement=document.createElement('script');"
										+"	    scriptElement.src='"+chrome.extension.getURL("jquery.js")+"';"
										+"	    document.body.appendChild(scriptElement);"
										+"	  }"
										+"	  document.body.removeChild(document.getElementById('RFTjQueryChecker'));"
										+"  }"
										+"}, 250);"
										+"})();");
	scriptElement.appendChild(node);
	document.body.appendChild(scriptElement);
}
function unblockUI()
{
	console.log("Window onload event - Unblocking UI");
	var mydiv = document.getElementById("rftplzwaitbanner");
	if (mydiv)
		mydiv.parentNode.removeChild(mydiv);
	insertJquery();
}
function blockUI()
{
	var initMsg = chrome.i18n.getMessage("pleaseWait");	var blocker = document.createElement("DIV");var imgPath = chrome.extension.getURL("images/busy.gif");
	var innerdiv =  "<div id= 'innerrftbanner' style=' opacity:0.8;font-size:30px ;position:fixed;top:5%;left:10%;height:29em;width:57em;margin-top:-1em; margin-left:-4em;text-align:center;padding:1em;background-color:#c0c0c0; z-index:1201 ;border-radius:25px;'><img src=\"" + imgPath + "\"><p>"+initMsg+"</div>";
	blocker.id="rftplzwaitbanner";blocker.innerHTML = innerdiv;document.body.appendChild(blocker);}

function ignoredoc() {
	if (document) {
		var url = document.URL;
		if ((url == "about:blank") || (url == "javascript:\"\"")|| (url.indexOf("rational_ft_log") > -1)) {	return true;}
		if(!isinframe()){return false;}//not in frame, inject applet.
		if(crossdomain()) return true;
		if(aframehasit()) return true;
		return false;
	}
	return true;// doc null
}
function aframehasit() {
	try {
		var topdoc = gettopdoc(document);
		var all = topdoc.defaultView.frames;
		var n = all.length;
		console.log(n+ ", frames in document  " + document.URL);
		var f;var d;var r;
		for(i = 0; i< n;i++){
			f = all[i];
			if(f != null)
				d = f.document;
			if (d != null)
				r = d.getElementById("RFTMiniIcon");
			if (r != null) {
				console.log("Found the rftapplet in " + f.document.URL);
				return true;
			}
		}
	} catch (e) {
		console.log("Exception occured " + e);
	}
	console.log("No frame has applet yet");
	return false;
}
function crossdomain() {
	console.log("Current host "+ document.location.host);
	try{
			var topdoc = gettopdoc(document);
			if(topdoc !=null  &&  (topdoc.location.host == document.location.host))
				return false;
			else
				return true;
			
		}catch(e)
		{
			console.log("Exception e in crossdomain "+ e)
			return true;
		}
}
function gettopdoc(doc)
{
	var maindoc = doc;
	try{
		var frame = maindoc.defaultView.frameElement;
		while(frame != null){
			maindoc = frame.ownerDocument;
			frame = maindoc.defaultView.frameElement;
		}
	}catch(e)
	{
		console.log("Error in getting top doc, returning topdoc as null "+e);
		return null;		
	}
	return maindoc;
}
function isinframe()
{
	var inframe = false;
	try{
		inframe = window.self !== window.top;
	}catch(e)
	{
		console.log("inframe check exception "+e);
	}
	return inframe;	
}

